/*#######################################################################################
AVR Ansteuerung 10/12 Bit PC-Datenerfassung LTC1290
Weitere Erkrungen siehe LTC1290.h

Copyright (C) 2005 Christian Truckenbrodt

#######################################################################################*/

#include "main.h"
#include "LTC1290.h"

void LTC1290_Init (void)
{	
	//internen PullUP fr CTS einschalten
	LTC1290_Port_Write = (1<<LTC1290_CTS); 
	//Aus- bzw. Eingnge einstellen
	LTC1290_Port_DDR   = (1<<LTC1290_DTR)|(1<<LTC1290_RTS);

}

void LTC1290_Wait (int value)
{
		//35us warten, da sonst die Signale zu schnell fr den LTC1290 sind
		//Zur ADwandlung 175us warten
		for (int k=1;k<=(SYSCLK*value/1000000);k++){;;} 
}

//############################################################################
//LTC1290 Ad Wandler Leseroutine
int LTC1290_Read (int kanal)
//############################################################################
{
	//Variablen deklarieren
	int i,j,messwert,bitwert;
	
	//Kanal in Steuerbit wandeln
	switch (kanal)
	{
		case 0: kanal = 0x8EF; break;
		case 1: kanal = 0xCEF; break;
		case 2: kanal = 0x9EF; break;
		case 3: kanal = 0xDEF; break;
		case 4: kanal = 0xAEF; break;
		case 5: kanal = 0xEEF; break;
		case 6: kanal = 0xBEF; break;
		case 7: kanal = 0xFEF; break;
	}
	
	//Insgesamt 2mal LTC1290 auslesen.
	//beim ersten mal Steuerbit bertragen und Messwert verwerfen
	//beim 2. mal Messwert endgltig einlesen
	for(j=1;j<=2;j++)
	{
		//Messwert und Bitwert auf Bit11 rcksetzen
		messwert = 0x00;
		bitwert  = 0x800;
		
		//Uebertrage und lese 12Bit. Beginne mit dem hchsten Bit
		for (i=11;i>=0;i--)
		{
			
			//DTR auf logisch 0 setzen
			LTC1290_Port_Write &=~ (1<<LTC1290_DTR);
			LTC1290_Wait (35);
			
			//Uebertrage jeweiliges Steuerbit
			//Wenn jeweiliges Steuerbit = 1 , dann RTS = 1
			if ( (kanal & bitwert) > 0 )
			{
				//RTS auf logisch 1 setzen
				LTC1290_Port_Write |= (1<<LTC1290_RTS);
				LTC1290_Wait (35);
			}
			else
			{
				//RTS auf logisch 0 setzen
				LTC1290_Port_Write &=~ (1<<LTC1290_RTS);
				LTC1290_Wait (35);
			}
			
			//DTR auf logisch 1 setzen
			LTC1290_Port_Write |= (1<<LTC1290_DTR);
			LTC1290_Wait (35);
			
			//Wenn CTS = 0 dann addiere bitwert zu messwert
			if( !(LTC1290_Port_Read & (1<<LTC1290_CTS)) ) messwert += bitwert;
			LTC1290_Wait (35);
			//Halbiere den Bitwert, damit er den Wert des nchsten "i" Durchgangs hat
			bitwert = bitwert /2;
			
		} //Ende for (i=11;i>=0;i--)
	
		//AD Wandlung starten
		//RTS auf logisch 0 setzen
		LTC1290_Port_Write &=~ (1<<LTC1290_RTS);
		LTC1290_Wait (35);
		//RTS auf logisch 1 setzen
		LTC1290_Port_Write |= (1<<LTC1290_RTS);
		LTC1290_Wait (35);
		//LTC1290 min. 175us Zeit zur Wandlung geben
		LTC1290_Wait (175); 
		
	
	} //Ende (j=1;j<=2;j++)
	
return (messwert);
}

